//
// Student.java
//

public class Student
{
    int studentId;
    int presList[];
    int preferenceSlot;
    int prob;
    int metric;

    Student(int id)
    {
	super();
	studentId = id;
	metric = 10;
    }

    public void probPreference()
    {
	presList = new int[ABM.NUM];
	preferenceSlot = ABM.RNG.nextInt(ABM.NUM);
	prob = ABM.RNG.nextInt(101);

	for (int i = 0; i < ABM.NUM; ++i) {
	    presList[i] = -1;
	}

	presList[preferenceSlot] = studentId;
    }

    public int getId() { return studentId; }
    public int getPreferenceSlot() { return preferenceSlot; }
    public int[] getPresList() { return presList; }
    public int getMetric() { return metric; }

    public void interactWith(Student other)
    {
	int slot = other.getPreferenceSlot();
	if (presList[slot] == -1) {
	    // nobody in that slot, agents gets it by default
	    presList[slot] = other.getId();
	} else {
	    // conflict, convince me
	    boolean convinced = other.convince();
	    if (convinced) {
		int old = presList[slot];
		presList[slot] = other.getId();
		if (old == studentId) {
		    // If I got displaced
		    // then randomly pick slot not filled
		    boolean done = false;
		    while (!done) {
			preferenceSlot = ABM.RNG.nextInt(ABM.NUM);
			if (presList[preferenceSlot] == -1)
			    presList[preferenceSlot] = studentId;
		    }
		    prob = ABM.RNG.nextInt(101);
		    --metric;
		    if (metric < 0) metric = 0;
		}
	    }
	}
    }

    /*
    public void interactWith(Student other)
    {
	int slot = other.getPreferenceSlot();
	if (presList[slot] == -1) {
	    // nobody in that slot, agents gets it by default
	    presList[slot] = other.getId();
	} else {
	    // conflict, convince me
	    boolean convinced = other.convince();
	    if (convinced) {
		int old = presList[slot];
		presList[slot] = other.getId();
		if (old == studentId) {
		    // If I got displaced
		    // then randomly pick new slot
		    preferenceSlot = ABM.RNG.nextInt(ABM.NUM);
		    prob = ABM.RNG.nextInt(101);
		    presList[preferenceSlot] = studentId;
		    --metric;
		    if (metric < 0) metric = 0;
		}
	    }
	}
    }
    */

    public boolean convince()
    {
	int i = ABM.RNG.nextInt(101);
	if (i < prob) return true;
	else return false;
    }

    public void printList()
    {
	for (int i = 0; i < ABM.NUM; ++i)
	    System.out.print(" " + presList[i]);
	System.out.print("  prob: " + prob);
    }

}
